<!DOCTYPE html>
<head>
	<link href="https://fonts.googleapis.com/css?family=Roboto" rel="stylesheet">
	<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.12.2/css/bootstrap-select.min.css">
	<link rel="stylesheet" href="https://unpkg.com/leaflet@1.0.3/dist/leaflet.css" />
	<link rel="stylesheet" href="css/styles.css">	
	<link href="https://gitcdn.github.io/bootstrap-toggle/2.2.2/css/bootstrap-toggle.min.css" rel="stylesheet">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.1.0/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa" crossorigin="anonymous"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/d3/3.5.17/d3.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/d3plus/1.9.8/d3plus.min.js"></script>
	<script src="https://gitcdn.github.io/bootstrap-toggle/2.2.2/js/bootstrap-toggle.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.17.1/moment.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datetimepicker/4.17.47/js/bootstrap-datetimepicker.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.12.2/js/bootstrap-select.min.js"></script>
	<script src="https://unpkg.com/leaflet@1.0.3/dist/leaflet.js"></script>
	<script src="http://d3js.org/topojson.v1.min.js" type="text/javascript"></script>

	
</head>
<body>
	<div id="loading"><div><img id="loading-image" src="css/images/spin.svg"/><br>Procesando datos...</div></div>
	<div id="menu">
		<nav class="navbar navbar-inverse">
			<div class="container-fluid">
				<div class="navbar-header">
					
				  <a class="navbar-brand" href="#">UNIVERSITYHACK 2017 DATATHON</a>
				  <div class="collapse navbar-collapse" style="display:inline-block !important;" id="bs-example-navbar-collapse-1">
					  <ul class="nav navbar-nav navbar-right">
						<li class="active"><a href="index.php">Estadísticas básicas <span class="sr-only">(current)</span></a></li>
						<li><a href="index2.php"><b>Planifica tus compras</b></a></li>
						<li><a style="color:#FF6A00" data-toggle="modal" data-target="#myModal"><b style="cursor:pointer;">¿Cómo usar esta herramienta?</b></a></li>
					  </ul>
					</div>
				</div>
			</div>
		</nav>
	</div>
	<div class="container">
		<div id="title">
			<center><h1>TRANSACCIONES BANCARIAS DE LA PROVINCIA DE VALENCIA</h1></center>
		</div>
		<div class="row">
			<div class="col-sm-3" style="padding-top: 5px;text-align: right;"><span>Seleccione el rango de días para la visualización: </span></div>
			<div class='col-sm-2'>
				<div class="form-group">
					<div class='input-group date' id='inferior'>
						<input type='text' class="form-control" />
						<span class="input-group-addon">
							<span class="glyphicon glyphicon-calendar"></span>
						</span>
					</div>
				</div>
			</div>
			<div class='col-sm-2'>
				<div class="form-group">
					<div class='input-group date' id='superior'>
						<input type='text' class="form-control" />
						<span class="input-group-addon">
							<span class="glyphicon glyphicon-calendar"></span>
						</span>
					</div>
				</div>
			</div>
			<div class='col-sm-3'>
				<div class="form-group">
					<select class="selectpicker">
						<option value="1">Importe</option>
						<option value="0">Transacciones</option>
						
					</select>
				</div>
			</div>
			<div class='col-sm-2'>
				<div class="form-group">
					<button id="procesar" type="button" class="btn btn-primary">Procesar</button>
				</div>
			</div>
        </div>
        <div class="visualization">
			<div class="first_col" id="barchart">
				<div id="visualization"></div>
				
			</div>
			<div class="first_col" id="linechart">
				<div id="visualization"></div>
			</div>
			<div class="second_col" id="treemap">
				<div id="treemap-title"><center><b><span >Distribución del Importe en las localidades Valencianas </span></center></b></div>
				<div id="visualization"></div>
			</div>
			<div class="second_col" id="map">
				<div id="map-title"><center><b><span>Ubicación gráfica del área seleccionada. </span></center></b></div>
				<div id="visualization"></div>
			</div>
		</div>
	</div>
	<!-- Modal -->
	<div id="myModal" class="modal fade" role="dialog">
		<div class="modal-dialog">

			<!-- Modal content-->
			<div class="modal-content">
			<div class="modal-header">
				<button type="button" class="close" data-dismiss="modal">&times;</button>
				<h4 class="modal-title">¿Cómo usar esta herramienta?</h4>
			</div>
			<div class="modal-body">
				<p>Inicialmente se observan cuatro tipos de gráficos: uno de barra, uno de línea, un treemap y un mapa</p>
				<h3>Búsqueda</h3>
				<p>En la primera columna existen 2 opciones seleccionables.</p>
				<p>La primera corresponde al rango de fechas que se seleccionará para procesar una nueva visualización</p>
				<p><img src="images/date.png"></p>
				<p>En el primer recuadro se debe seleccionar la fecha inferior, mientras que en el segundo la fecha superior.</p>
				<p>Al lado de la fecha, se encuentra un pequeño recuadro desplegable con dos opciones seleccionables.</p>
				<p><img src="images/tipo.png"></p>
				<p>Esto corresponde al tipo de visualización que se desplegará, es decir, si se privilegiará los importes en euros gastados, o por otro lado el número de transacciones realizadas.</p>
				<p>Finalmente se debe clickear el botón para cargar la nueva visualización</p>
				<p><img src="images/boton.png"></p>
				<h3>Gráfico de Barra</h3>
				<p>Este gráfico despliega las áreas del comercio en donde se realizaron las transacciones.</p>
				<p><img src="images/barchart.png"></p>
				<p>Si se clickea una barra, los gráficos posteriores cambiarán automáticamente para relacionarlos exclusivamente con esta área comercial.</p>
				<h3>Gráfico de Línea</h3>
				<p>Este gráfico muestra la evolución histórica de las transacciones</p>
				<p><img src="images/linechart.png"></p>
				<h3>Treemap</h3>
				<p>En su vista inicial, cada cuadrante corresponde a la localidad desde donde se realizó la transacción</p>
				<p><img src="images/treemap.png"></p>
				<p>Al hacer click en un cuadrante, se observarán las localidades en donde se realizaron las transacciones desde la localidad seleccionada.</p>
				<p><img src="images/treemap2.png"></p>
				<p>Es decir, a modo de ejemplo, si en una primera instancia se selecciona la localidad de Mislata, a continuación se observará las localidades preferidas de la gente de Mislata para comprar sus productos y/o servicios.</p>
				<h3>Mapa</h3>
				<p>Al hacer click en algún cuadrante del treemap del costado, se podrá ver geográficamente la ubicación espacial de esta zona en el mapa. </p>
				<p><img src="images/map.png"></p>
			</div>
			<div class="modal-footer">
				<button type="button" class="btn btn-default" data-dismiss="modal">Cerrar</button>
			</div>
		</div>

	</div>
	</div>
	<script>
		$( document ).ajaxStart(function() {
			$("#loading").show();
		});
		
		$( document ).ajaxStop(function() {
			$("#loading").hide();
		});
		
		function generateMap(zip,zoom){
			width = $("#map #map-title").width()
			height = $("#treemap #visualization").height()
			url = "//www.google.com/maps/embed/v1/place?q="+zip+",%20Valencia,%20España&zoom="+zoom+"&key=AIzaSyBBObzsV_lZGo8VpWCcSUeIM9h1plpbEI8"
			$("#map #visualization").html("<iframe frameborder=0 width='"+width+"' height='"+height+"' src='"+url+"'></iframe>")
		}
		
		function barchart(data,type){
			$("#barchart #visualization").empty()
			var visualization = d3plus.viz()
				.container("#barchart #visualization")
				.data(data)
				.type("bar")
				.id("Tipo de Comercio")
				.x("Tipo de Comercio")
				.y(type)
				.format("es_ES")
				.resize( true )
				.mouse({
						"click":function(o){
								$.post("webservice/get_historic.php",{"name":o["Tipo de Comercio"],"yinf":$("#inferior input").val(),"ysup":$("#superior input").val()},function(data){
										json = $.parseJSON(data)
										type = "transacciones"
										if ($(".bootstrap-select button")[0].title == "Importe")
											type = "importe"
											
										linechart(json,type)
									})
								$.post("webservice/get_comerce.php",{"name":o["Tipo de Comercio"],"yinf":$("#inferior input").val(),"ysup":$("#superior input").val()},function(data){
										json = $.parseJSON(data)
										type = "transacciones"
										if ($(".bootstrap-select button")[0].title == "Importe")
											type = "importe"
											
										treemap(json,type)
									})
							
							}
					})
				.draw()
		}
		
		function treemap(data,type){
			
			$("#treemap #visualization").empty()
			var visualization = d3plus.viz()
					.container("#treemap #visualization")  // container DIV to hold the visualization
					.data(data)  // data to use with the visualization
					.type("tree_map")   // visualization type
					.resize( true )
					.id(["group","Tipo de Comercio"])         // key for which our data is unique on
					.size(type)      // sizing of blocks
					.format("es_ES")
					.draw()
			$("#treemap #visualization").on(
						{
							click:function(o){
								zip = "zip "+(this.__data__.group).split(" (")[1].replace(")","")
								name = (this.__data__.group).split(" (")[0]
								generateMap(zip+", "+name,13)
								type = $(".bootstrap-select button").text()
								if (type == "Importe")
									type = "del Importe"
								else
									type = "de las transacciones"
								if (this.__data__["Tipo de Comercio"][0].length != 1){
									$("#treemap-title span").text("Distribución "+type+" de la localidad de "+name )
								}else{
									$("#treemap-title span").text("Distribución "+type+" en las localidades Valencianas")
								}
								
							}
						},'g.d3plus_rect rect');
		}
		
		function linechart(data,type){
			$("#linechart #visualization").empty()
			var visualization = d3plus.viz()
			.container("#linechart #visualization")  // container DIV to hold the visualization
			.data(data)  // data to use with the visualization
			.type("line")       // visualization type
			.id("Tipo de Comercio")         // key for which our data is unique on
			.text("Tipo de Comercio")       // key to use for display text
			.y(type)         // key to use for y-axis
			.x("Fecha")          // key to use for x-axis
			.resize( true )
			.format("es_ES")
			.draw()  
		}
		
		$(window).resize(function(){
			$(".visualization").height($(window).height()-$("#menu").height()-$("#title").height()-$(".container>.row").height()-$("#treemap-title").height()-20)
			$("#linechart").height("40%")
			$("#barchart").height("40%")
		})
		
		$(document).ready(function(){
			$(".visualization").height($(window).height()-$("#menu").height()-$("#title").height()-$(".container>.row").height()-$("#treemap-title").height()-20)
			$("#linechart").height("40%")
			$("#barchart").height("40%")
			
			$('#superior').datetimepicker({
				format:"YYYY/MM/DD",
				
				minDate:moment("01/01/2015"),
				maxDate:moment("12/31/2016"),
				defaultDate:moment("12/31/2016"),
				useCurrent:false,
				
			});
			$('#inferior').datetimepicker({
				format:"YYYY/MM/DD",
				
				minDate:moment("01/01/2015"),
				maxDate:moment("12/31/2016"),
				defaultDate:moment("08/01/2016"),
				useCurrent:false,
				
			});
			
			$.post("webservice/get_sector.php",
				{"yinf":$("#inferior input").val(),"ysup":$("#superior input").val()},function( data ) {
					json = $.parseJSON(data)
					barchart(json,"importe")
					$.post("webservice/get_historic.php",{"name":"","yinf":$("#inferior input").val(),"ysup":$("#superior input").val()},function(data){
						json = $.parseJSON(data)
						linechart(json,"importe")
					})
					$.post("webservice/get_comerce.php",{"name":"","yinf":$("#inferior input").val(),"ysup":$("#superior input").val()},function(data){
						json = $.parseJSON(data)
						treemap(json,"importe")
						generateMap("Provincia Valencia",8)
					})
					
					
				})
			$('#procesar').click(function() {
				if ($(".bootstrap-select button")[0].title == "Importe"){
					$.post("webservice/get_sector.php",
						{"yinf":$("#inferior input").val(),"ysup":$("#superior input").val()},function( data ) {
							json = $.parseJSON(data)
							barchart(json,"importe")
							$.post("webservice/get_historic.php",{"name":"","yinf":$("#inferior input").val(),"ysup":$("#superior input").val()},function(data){
								json = $.parseJSON(data)
								linechart(json,"importe")	
							})
							$.post("webservice/get_comerce.php",{"name":"","yinf":$("#inferior input").val(),"ysup":$("#superior input").val()},function(data){
								json = $.parseJSON(data)
								treemap(json,"importe")
								generateMap("Provincia Valencia",8)
							})
							
						})
				}else{
					$.post("webservice/get_sector.php",
						{"yinf":$("#inferior input").val(),"ysup":$("#superior input").val()},function( data ) {
							json = $.parseJSON(data)
							barchart(json,"transacciones")
							$.post("webservice/get_historic.php",{"name":"","yinf":$("#inferior input").val(),"ysup":$("#superior input").val()},function(data){
								json = $.parseJSON(data)
								linechart(json,"transacciones")
							})
							$.post("webservice/get_comerce.php",{"name":"","yinf":$("#inferior input").val(),"ysup":$("#superior input").val()},function(data){
								json = $.parseJSON(data)
								treemap(json,"transacciones")
								generateMap("Provincia Valencia",8)
							})
							
						})
				}
			})
		})
	
	</script>
</body>
</html>
